
Ruby - Bug #3827

ext/readline can't handle cursor keys and cp932 chars

09/14/2010 08:54 PM - arton (Akio Tajima)

Status: Closed   

Priority: Normal   

Assignee: arton (Akio Tajima)   

Target version: 1.9.3   

ruby -v: ruby 1.9.2p0 (2010-08-18 revision

29036) [i386-mswin32_100]

Backport:  

Description

=begin

Ruby-1.9.2-p0のext/readlineと、GNU libreadline-4.3.2 (

http://jarp.does.notwork.org/win32/)の組み合わせでカーソルキー、Home/Endキーなどの特殊キーの入力ができません。また、2バイトコードのうちMSBがオフのコードのみが通ります

。例）「表」であれば2バイト目の「\」のみが通る。）

原因は、複合的です。

・1.9.2のext/readlineはIO.getbyteを呼び出していますが、win32の1.9.2の実装ではカーソルキーなどの特殊キーを読めません。そのため無視されています。

・MBCSが符号拡張されてlibreadlineに渡されているので、無視されています。

添付のパッチは、win32の場合は、IO.getbyteではなくlibreadlineのrl_getcを呼び出すようにしたものです。この中で入力の有無を判断してwait_eventsを呼び出すようにしています。

=end

Associated revisions

Revision e49f8909 - 06/21/2011 04:30 AM - kouji (Kouji Takao)

ext/readline/readline.c (readline_getc): applied a patch in

#3827 by by Akio Tajima . (see #3827)

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@32181 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 09/28/2010 12:27 PM - naruse (Yui NARUSE)

- Category set to ext

- Status changed from Open to Assigned

- Assignee set to kouji (Kouji Takao)

=begin

=end

#2 - 06/11/2011 03:19 PM - ko1 (Koichi Sasada)

高尾さん

本件，いかがでしょうか．

#3 - 06/21/2011 11:39 AM - kouji (Kouji Takao)

Koichi Sasada wrote:

高尾さん

本件，いかがでしょうか．

 こちらで試せるようなWin32環境がありません。一旦取り込みますので、試してみていただけないでしょうか。 > Akio Tajima さん

#4 - 06/21/2011 02:05 PM - kouji (Kouji Takao)

r32181にてパッチをコミットしました。お手数をおかけしますが、確認いただけますでしょうか。

#5 - 06/26/2011 05:13 PM - nahi (Hiroshi Nakamura)
http://jarp.does.notwork.org/win32/)%E3%81%AE%E7%B5%84%E3%81%BF%E5%90%88%E3%82%8F%E3%81%9B%E3%81%A7%E3%82%AB%E3%83%BC%E3%82%BD%E3%83%AB%E3%82%AD%E3%83%BC%E3%80%81Home/End%E3%82%AD%E3%83%BC%E3%81%AA%E3%81%A9%E3%81%AE%E7%89%B9%E6%AE%8A%E3%82%AD%E3%83%BC%E3%81%AE%E5%85%A5%E5%8A%9B%E3%81%8C%E3%81%A7%E3%81%8D%E3%81%BE%E3%81%9B%E3%82%93%E3%80%82%E3%81%BE%E3%81%9F%E3%80%812%E3%83%90%E3%82%A4%E3%83%88%E3%82%B3%E3%83%BC%E3%83%89%E3%81%AE%E3%81%86%E3%81%A1MSB%E3%81%8C%E3%82%AA%E3%83%95%E3%81%AE%E3%82%B3%E3%83%BC%E3%83%89%E3%81%AE%E3%81%BF%E3%81%8C%E9%80%9A%E3%82%8A%E3%81%BE%E3%81%99%E3%80%82%E4%BE%8B%EF%BC%89%E3%80%8C%E8%A1%A8%E3%80%8D%E3%81%A7%E3%81%82%E3%82%8C%E3%81%B02%E3%83%90%E3%82%A4%E3%83%88%E7%9B%AE%E3%81%AE%E3%80%8C%5C%E3%80%8D%E3%81%AE%E3%81%BF%E3%81%8C%E9%80%9A%E3%82%8B%E3%80%82%EF%BC%89
http://jarp.does.notwork.org/win32/)%E3%81%AE%E7%B5%84%E3%81%BF%E5%90%88%E3%82%8F%E3%81%9B%E3%81%A7%E3%82%AB%E3%83%BC%E3%82%BD%E3%83%AB%E3%82%AD%E3%83%BC%E3%80%81Home/End%E3%82%AD%E3%83%BC%E3%81%AA%E3%81%A9%E3%81%AE%E7%89%B9%E6%AE%8A%E3%82%AD%E3%83%BC%E3%81%AE%E5%85%A5%E5%8A%9B%E3%81%8C%E3%81%A7%E3%81%8D%E3%81%BE%E3%81%9B%E3%82%93%E3%80%82%E3%81%BE%E3%81%9F%E3%80%812%E3%83%90%E3%82%A4%E3%83%88%E3%82%B3%E3%83%BC%E3%83%89%E3%81%AE%E3%81%86%E3%81%A1MSB%E3%81%8C%E3%82%AA%E3%83%95%E3%81%AE%E3%82%B3%E3%83%BC%E3%83%89%E3%81%AE%E3%81%BF%E3%81%8C%E9%80%9A%E3%82%8A%E3%81%BE%E3%81%99%E3%80%82%E4%BE%8B%EF%BC%89%E3%80%8C%E8%A1%A8%E3%80%8D%E3%81%A7%E3%81%82%E3%82%8C%E3%81%B02%E3%83%90%E3%82%A4%E3%83%88%E7%9B%AE%E3%81%AE%E3%80%8C%5C%E3%80%8D%E3%81%AE%E3%81%BF%E3%81%8C%E9%80%9A%E3%82%8B%E3%80%82%EF%BC%89


- Assignee changed from kouji (Kouji Takao) to arton (Akio Tajima)

- Target version set to 1.9.3

#6 - 07/10/2011 03:35 PM - kosaki (Motohiro KOSAKI)

artonさん、こちら、いかがでしょうか？

#7 - 07/11/2011 02:42 PM - usa (Usaku NAKAMURA)

ちょっと見てみました。

o カーソルキー -> 使えるようになった

o HomeおよびEndキー -> 使えるようになった

o マルチバイト文字 -> 入力できるようになった

x マルチバイト文字に対するバックスペース -> 1バイトだけ消しやがる

とりあえず、rubyとしては問題解決と言えると思います(最後の1個はreadlineのせいだと思いたい)。

#8 - 07/11/2011 02:45 PM - kosaki (Motohiro KOSAKI)

- Status changed from Assigned to Closed

確認がとれたようなのでcloseします。また問題が起きたら別チケット作りましょう

Files

readline.patch 1.44 KB 09/14/2010 arton (Akio Tajima)
